import { createSignal, onMount } from "solid-js";

const UserSettings = (props) => {
  const [prename, setPrename] = createSignal("");
  const [surname, setSurname] = createSignal("");
  const [age, setAge] = createSignal("");
  const [zip, setZip] = createSignal("");
  const [city, setCity] = createSignal("");
  const [image, setImage] = createSignal(null);
  const [imageUrl, setImageUrl] = createSignal(null);
  const [user, setUser] = createSignal({});

  let imgBaseUrl = 'http://localhost:3000/images/persons/'
  
  onMount(() => {
    let userFromLocalStorage = JSON.parse(localStorage.getItem("user"));   
    setUser(userFromLocalStorage); 
    setPrename(userFromLocalStorage.prename); 
    setSurname(userFromLocalStorage.surname); 
    setCity(userFromLocalStorage.city); 
    setAge(userFromLocalStorage.age); 
    setImageUrl(imgBaseUrl + userFromLocalStorage.img)
  });


  const handleImageUpload = async(file) => {
    const data = new FormData();
    data.append("image", file);
    data.append("type", file.type);
    data.append("name", file.name);
    data.append("personId", props.personId); 
    let token =  localStorage.getItem("token"); 
    const requestOptions = {
        method: 'POST',
        body: data,
        headers: { authorization: "Bearer " + token }
    };
    let response = await fetch(baseUrlPersonImg, requestOptions);
    // Abfrage starten. 
    let json = await response.json(); 
    // ÜBUNG: Funktion fertig schreiben. 

  };

  const handleSave = () => {
    // Implement the save logic here
    console.log("Saved:", { prename: prename(), surname: surname(), age: age(), zip: zip(), city: city() });
  };

  return (
    <div class="grid grid-cols-2 gap-4 p-4">
      <div class="flex flex-col items-center">
        <img src={imageUrl() || "https://via.placeholder.com/150"} alt="Profile" class="w-40 h-40 object-cover mb-4 rounded-full" />
        <input type="file" accept="image/*" class="file-input file-input-bordered w-full max-w-xs" onChange={handleImageUpload} />
      </div>
      <div class="flex flex-col space-y-2">
        <div class="form-control">
          <label class="label">
            <span class="label-text">Prename</span>
          </label>
          <input type="text" class="input input-bordered" value={prename()} onInput={(e) => setPrename(e.target.value)} />
        </div>
        <div class="form-control">
          <label class="label">
            <span class="label-text">Surname</span>
          </label>
          <input type="text" class="input input-bordered" value={surname()} onInput={(e) => setSurname(e.target.value)} />
        </div>
        <div class="form-control">
          <label class="label">
            <span class="label-text">Age</span>
          </label>
          <input type="number" class="input input-bordered" value={age()} onInput={(e) => setAge(e.target.value)} />
        </div>
        <div class="form-control">
          <label class="label">
            <span class="label-text">City</span>
          </label>
          <input type="text" class="input input-bordered" value={city()} onInput={(e) => setCity(e.target.value)} />
        </div>
        <button class="btn btn-primary mt-4" onClick={handleSave}>Save</button>
      </div>
    </div>
  );
};

export default UserSettings;
